package org.opengroup.osdu.notification.provider.azure.messageBus.thread;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.opengroup.osdu.core.common.model.http.DpsHeaders;
import org.springframework.beans.factory.ObjectFactory;
import org.springframework.mock.web.MockHttpServletRequest;
import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertNull;
import static org.mockito.Mockito.when;

@RunWith(MockitoJUnitRunner.class)
public class ThreadScopeTest {
    private static final String NAME = "name";

    @InjectMocks
    ThreadScope threadScope;
    @Mock
    ObjectFactory<Object> factory;
    @Mock
    DpsHeaders dpsHeaders;
    @Mock
    MockHttpServletRequest request;
    @Mock
    ThreadScopeContext context;
    @Mock
    ThreadDpsHeaders threadDpsHeaders;

    @Before
    public void setup() {
        MockitoAnnotations.openMocks(ThreadScopeTest.this);
    }

    @Test
    public void getTest_shouldGetObject() {
        when(factory.getObject()).thenReturn(new Object());
        Object actual = threadScope.get(NAME, factory);
        assertNotNull(actual);
    }

    @Test
    public void removeTest_shouldReturnRemovedObject(){
        threadScope.get(NAME,factory);
        threadScope.registerDestructionCallback(NAME, () -> {});
        Object actual = threadScope.remove(NAME);
        assertNull(actual);
    }

}

