/* Licensed Materials - Property of IBM              */		
/* (c) Copyright IBM Corp. 2020. All Rights Reserved.*/	

package org.opengroup.osdu.notification.provider.ibm.di;
import org.opengroup.osdu.core.common.util.IServiceAccountJwtClient;
import org.opengroup.osdu.notification.provider.ibm.util.AppProperties;
import org.opengroup.osdu.notification.provider.ibm.util.ServiceAccountJwtIBMClientImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.AbstractFactoryBean;
import org.springframework.stereotype.Component;


public class ServiceAccountJwtClientFactory extends AbstractFactoryBean<IServiceAccountJwtClient> {

	
    @Override
    public IServiceAccountJwtClient createInstance() throws Exception {
        return new ServiceAccountJwtIBMClientImpl();
    }

    @Override
    public Class<?> getObjectType() {
        return IServiceAccountJwtClient.class;
    }
}
